var debug = true;
if (!debug) {
    var console = {};
    console.log = function(){};
}

function mergeOpts(opts, resourceOpts) {
    opts.labelStart = resourceOpts.labelStart;
    opts.labelEnd = resourceOpts.labelEnd;
    opts.staticZones = resourceOpts.staticZones;
    opts.staticLabels = resourceOpts.staticLabels;
    opts.minValue = resourceOpts.minValue;
    opts.maxValue = resourceOpts.maxValue;
    console.log('Merged: ');
    console.log(snogOpts);

    return opts;
}

function runGauge(gauge, snogOpts, resourceOpts) {
    gauge.setOptions(mergeOpts(gauge.getDefaultOpts(), resourceOpts));
    gauge.set(0);
    var snogComm = new SNOGComm(snogOpts);
    snogComm.run();
}

function onLoadFn() {
    var gaugeElement = document.getElementById("gauge");
    gaugeElement.className += 'tooltip';

    var tooltipElement = document.createElement('span');
    tooltipElement.className += 'tooltiptext';
    gaugeElement.appendChild(tooltipElement);

    var canvasElement = document.createElement('canvas');
    canvasElement.id = 'gauge-canvas';
    canvasElement.setAttribute("style","width:" + gaugeElement.clientWidth + "px; height:" + (gaugeElement.clientHeight*0.85) + "px; opacity: 0.3;");
    gaugeElement.appendChild(canvasElement);

    var labelDivElement = document.createElement('div');
    labelDivElement.id = 'gauge-textfield';
    labelDivElement.setAttribute("style","font-size:" + (gaugeElement.clientHeight/15)+ "px;");

    gaugeElement.appendChild(labelDivElement);

    var loaderElement = document.createElement('div');
    loaderElement.id = 'loader';
    gaugeElement.appendChild(loaderElement);

    function hideLoadbar() {
        canvasElement.setAttribute("style","width:" + gaugeElement.clientWidth + "px; height:" + (gaugeElement.clientHeight*0.85) + "px; opacity: 1;");
        loaderElement.style.display = 'none';
    }

    var gauge = new Gauge(canvasElement);
    gauge.setTextFieldDiv(labelDivElement);
    gauge.animationSpeed = 32;

    var snogOpts = {
        username: 'public@cythres.cz', // SNOG username
        password: '1234', // SNOG password
        server: 'cythres', // server name
        unitId: 999, // SNOG unit ID
        resourceId: 17, // SNOG resource ID
        measurementCnt: 3, // number of last measurements shown in gauge
        htmlTooltip: tooltipElement, // HTML element for timer
        gauge: gauge, // gauge instance
        updateTimerTime: 60000, // update time for timer requesting new values from server [ms], if value == 0, data request is sent only once, not in the loop
        htmlLoadbarFunction: hideLoadbar, // function that handles loadbar hiding
        updateLabelStr: 'Aktualizace dat: ', // string for label with "Last update" information
        lastMeasuredStr: 'Poslední naměřené hodnoty: ',
    };

    getResourceProperties(gauge, snogOpts);
}