function SNOGComm (snogOpts) {
    var global = this;
    this.server = snogOpts.server;
    this.username = snogOpts.username;
    this.password = snogOpts.password;
    this.unitId = snogOpts.unitId;
    this.resourceId = snogOpts.resourceId;
    this.valuesCount = snogOpts.measurementCnt;
    this.tooltipSpan = snogOpts.htmlTooltip;
    this.token = null;
    this.gauge = snogOpts.gauge;
    this.hideLoadbar = snogOpts.htmlLoadbarFunction;
    this.updateStr = snogOpts.updateLabelStr;
    this.lastMeasuredStr = snogOpts.lastMeasuredStr;
    this.updateTimerTime = snogOpts.updateTimerTime;
    console.log(this.lastMeasuredStr);

    this.timerFunction = function() {
        var dateTo = new Date();
        var lastUpdateTime = document.getElementById("lastUpdateTime");
        var dateFrom = new Date();
        dateFrom.setHours(dateFrom.getHours() - 1);
        var dateFromGMT = Math.floor(dateFrom.getTime()/1000);
        console.log(dateFrom);
        console.log(dateFromGMT);
        var dateToGMT = Math.floor(dateTo.getTime()/1000);
        console.log(dateTo);
        console.log(dateToGMT);
        console.log('Token: ' + window.token);
        console.log('Unit: ' + this.unitId);
        console.log('ResourceID: ' + this.resourceId);
        console.log('Count: ' + this.valuesCount);

        try {
            console.log('data request sent.');
            if (window.timerUrl == null) window.timerUrl = 'https://snog.' + this.server + '.cz/sn/rest/api/' + window.token + '/unit/' + this.unitId + '/' + this.resourceId + '/' + this.valuesCount;
            console.log(window.timerUrl);
            global.timerRequest.open('GET', window.timerUrl, true);
            global.timerRequest.responseType='';
            global.timerRequest.setRequestHeader('Content-type', 'application/x-www-form-urlencoded');
            global.timerRequest.send();

        } catch (err) {
            console.log('Timer error: ' + err);
        }
    }

    this.request = new XMLHttpRequest();
    this.request.onload = function() {
            // getToken response
        console.log('Status: ' + this.status);
        if (this.status >= 200 && this.status < 400) {
            var xmlBody = this.responseText.replace(/\<\?xml.+\?\>|\<\!DOCTYPE.+]\>/g, ''); // odstranime <?xml .. > a <!DOCTYPE ...>
            var parser = new DOMParser();
            var xmlDoc = parser.parseFromString(xmlBody,"text/xml");
    
            token = xmlDoc.getElementsByTagName("token")[0].childNodes[0].nodeValue; // parse token and run timer function
            global.timerFunction();
            if (global.updateTimerTime > 0) {
              window.setInterval(global.timerFunction, global.updateTimerTime); 
            }
        } else {
            console.log('error')
        }
    }
    
    this.request.onerror = function() {
        console.log('ERROR - status: ' + this.request.status);
        
    };
    this.request.onreadystatechange = function (oEvent) {
        if (this.readyState === 4) {
            if (this.status === 200) {
            console.log(this.response)
            } else {
                console.log("Error - status: ", global.request.status);
            }
        }
    };

    this.timerRequest = new XMLHttpRequest();
    this.timerRequest.onload = function () {
        console.log('Timer status: ' + this.statusText);
        if (this.status >= 200 && this.status < 400) {
            try {
                //console.log(timerRequest.response);
                var timerXmlBody = this.responseText.replace(/\<\?xml.+\?\>|\<\!DOCTYPE.+]\>/g, ''); // odstranime <?xml .. > a <!DOCTYPE ...>
                var timerParser = new DOMParser();
                var timerXmlDoc = timerParser.parseFromString(timerXmlBody,"text/xml");
                console.log(timerXmlBody); 
                global.hideLoadbar();
                if (typeof global.gauge !== 'undefined' && global.gauge !== null) {
                    measurements = timerXmlDoc.getElementsByTagName("measurementCooked");
                    vals = new Array(global.valuesCount).fill(0);
                    tooltipStr = '';
                    
                    for (i = 0; i < measurements.length && i < vals.length; i++) {
                        if (i == 0) {
                            dateNow = new Date();
                            tooltipStr = global.updateStr + dateNow.getDate() + '.' + dateNow.getMonth() + '.' + dateNow.getFullYear() + ' ' + dateNow.getHours() + ':' + String(dateNow.getMinutes()).padStart(2,'0') + ':' + String(dateNow.getSeconds()).padStart(2,'0') + '<br/>' + global.lastMeasuredStr;
                        }
                        date = new Date(measurements[i].getAttribute("readAt"));
                        tooltipStr +=  '</br> - <b>' + measurements[i].getAttribute("value") + ' ' + global.gauge.getLabelEnd() + '</b> (' + date.getDate() + '.' + date.getMonth() + '.' + date.getFullYear() + ' ' + date.getHours() + ':' + String(date.getMinutes()).padStart(2,'0') + ':' + String(date.getSeconds()).padStart(2,'0') + ')';
                        vals[i] = measurements[i].getAttribute("value");
                    }
                    global.gauge.set(vals);
                    global.tooltipSpan.innerHTML = tooltipStr;
                }
            } catch (ex) {
                console.log(ex.message);
            }
        } else {
            console.log('timerRequest: error')
        }
    };
};

SNOGComm.prototype.run = function() {
    this.tooltipSpan.innerHTML = this.updateStr;
    var url = 'https://snog.' + this.server + '.cz/sn/rest/api/login';
    console.log('url: ' + url);
    this.request.open('POST', url, true);
    this.request.responseType='';
    this.request.setRequestHeader('Content-type', 'application/x-www-form-urlencoded');
    try {
        this.request.send('u=' + this.username + '&p=' + this.password);
    } catch (err) {
        console.log(err.description);
        console.log('Ready state: ' + this.request.readyState);
    }    
}